part of keyclic_sdk_api.api;



class PersonApi {
  final ApiClient apiClient;

  PersonApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  /// Retrieve all Person resources.
  ///
  /// 
  Future<PersonPagination> cgetPeople(String xKeyclicApp, { String acceptLanguage, String xKeyclicAppVersion, int page, int limit, String order, DateTime after, DateTime before, String search[familyName], String search[givenName], String search[jobTitle], String search[username], String search[email] }) async {
    Object postBody = null;

    // verify required params are set
    if(xKeyclicApp == null) {
     throw new ApiException(400, "Missing required param: xKeyclicApp");
    }

    // create path and map variables
    String path = "/people".replaceAll("{format}","json");

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    if(page != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "page", page));
    }
    if(limit != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "limit", limit));
    }
    if(order != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "order", order));
    }
    if(after != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "after", after));
    }
    if(before != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "before", before));
    }
    if(search[familyName] != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "search[familyName]", search[familyName]));
    }
    if(search[givenName] != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "search[givenName]", search[givenName]));
    }
    if(search[jobTitle] != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "search[jobTitle]", search[jobTitle]));
    }
    if(search[username] != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "search[username]", search[username]));
    }
    if(search[email] != null) {
      queryParams.addAll(_convertParametersForCollectionFormat("", "search[email]", search[email]));
    }
    headerParams["accept-language"] = acceptLanguage;
headerParams["x-keyclic-app"] = xKeyclicApp;
headerParams["x-keyclic-app-version"] = xKeyclicAppVersion;

    List<String> contentTypes = ["application/json;charset=UTF-8"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["bearer"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'PersonPagination') as PersonPagination ;
    } else {
      return null;
    }
  }
  /// Retrieve one Person resource.
  ///
  /// 
  Future<Person> getPerson(String xKeyclicApp, String person, { String acceptLanguage, String xKeyclicAppVersion }) async {
    Object postBody = null;

    // verify required params are set
    if(xKeyclicApp == null) {
     throw new ApiException(400, "Missing required param: xKeyclicApp");
    }
    if(person == null) {
     throw new ApiException(400, "Missing required param: person");
    }

    // create path and map variables
    String path = "/people/{person}".replaceAll("{format}","json").replaceAll("{" + "person" + "}", person.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["accept-language"] = acceptLanguage;
headerParams["x-keyclic-app"] = xKeyclicApp;
headerParams["x-keyclic-app-version"] = xKeyclicAppVersion;

    List<String> contentTypes = ["application/json;charset=UTF-8"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["bearer"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'GET',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'Person') as Person ;
    } else {
      return null;
    }
  }
  /// Edit one Person resource.
  ///
  /// 
  Future<Person> patchPerson(String xKeyclicApp, PersonPatch personPatch, String person, { String acceptLanguage, String xKeyclicAppVersion }) async {
    Object postBody = personPatch;

    // verify required params are set
    if(xKeyclicApp == null) {
     throw new ApiException(400, "Missing required param: xKeyclicApp");
    }
    if(personPatch == null) {
     throw new ApiException(400, "Missing required param: personPatch");
    }
    if(person == null) {
     throw new ApiException(400, "Missing required param: person");
    }

    // create path and map variables
    String path = "/people/{person}".replaceAll("{format}","json").replaceAll("{" + "person" + "}", person.toString());

    // query params
    List<QueryParam> queryParams = [];
    Map<String, String> headerParams = {};
    Map<String, String> formParams = {};
    headerParams["accept-language"] = acceptLanguage;
headerParams["x-keyclic-app"] = xKeyclicApp;
headerParams["x-keyclic-app-version"] = xKeyclicAppVersion;

    List<String> contentTypes = ["application/json;charset=UTF-8"];

    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";
    List<String> authNames = ["bearer"];

    if(contentType.startsWith("multipart/form-data")) {
      bool hasFields = false;
      MultipartRequest mp = new MultipartRequest(null, null);
      
      if(hasFields)
        postBody = mp;
    }
    else {
          }

    var response = await apiClient.invokeAPI(path,
                                             'PATCH',
                                             queryParams,
                                             postBody,
                                             headerParams,
                                             formParams,
                                             contentType,
                                             authNames);

    if(response.statusCode >= 400) {
      throw new ApiException(response.statusCode, response.body);
    } else if(response.body != null) {
      return 
          apiClient.deserialize(response.body, 'Person') as Person ;
    } else {
      return null;
    }
  }
}
